#include <stdio.h>
#include <string.h>
#define MAXSIZE 5
int compareTwoString(char str1[], char str2[]);
void insertionSortByName(char name[][20], int score[]);
int binarySearchByIteration(char name[][20], char key[], int left, int right);
int binarySearchByRecursion(char name[][20], char key[], int left, int right);

int main()
{
	char name[MAXSIZE][20] = { "̿", "ö", "ȫ浿", "տ", "ڹμ" };
	int score[MAXSIZE] = { 80, 90, 60, 50, 70 };
	int i, n;
	char key[20];
	printf("̸ Է: ");
/*	scanf("%s", key);  */
	scanf_s("%s", key, sizeof(key));

	insertionSortByName(name, score);
	/* name ĵ   */
	for (i = 0; i < MAXSIZE; i++)
		printf("\n%s %d", name[i], score[i]);
	n = binarySearchByIteration(name, key, 0, MAXSIZE - 1);
	/*	n = binarySearchByRecursion(name, key, 0, MAXSIZE-1);  */
	if (n < 0)
		printf("\n\n%s ϴ.", key);
	else
		printf("\n\n%s  %dԴϴ.", key, score[n]);
	return 0;
}
void insertionSortByName(char name[][20], int score[]) /*   */
{
	int i, j;
	int tmp;
	char tmpStr[20];
	for (i = 1; i < MAXSIZE; i++)
	{
/*		strcpy(tmpStr, name[i]);  */
		strcpy_s(tmpStr, sizeof(tmpStr), name[i]);

		tmp = score[i];
		for (j = i - 1; j >= 0 && strcmp(tmpStr, name[j]) < 0; j--)
		{
		/*	strcpy(name[j + 1], name[j]);  */
			strcpy_s(name[j + 1], sizeof(name[j + 1]), name[j]);

			/*  ġ ٲ  score 迭 ġ ؾ
			 ÷ڰ ġ */
			score[j + 1] = score[j];
		}
	/*	strcpy(name[j + 1], tmpStr);  */
		strcpy_s(name[j + 1], sizeof(name[j + 1]), tmpStr);
		score[j + 1] = tmp;
	}
}

int binarySearchByIteration(char name[][20], char key[], int left, int right)
{
	/* key name  ش ÷ڸ ȯϰ,  -1 ȯ */
	int middle;
	while (left <= right)
	{
		middle = (left + right) / 2;
		/* printf("\nleft = %d, right = %d, middle = %d", left, right, middle); */
		switch (compareTwoString(key, name[middle]))
		{
		case -1:
			right = middle - 1;
			break;
		case 0:
			return middle;
		case 1:
			left = middle + 1;
			break;
		}
	}
	return -1;
}

int binarySearchByRecursion(char name[][20], char key[], int left, int right)
{
	/* key name  ش ÷ڸ ȯϰ,  -1 ȯ */
	int middle;
	/* printf("\nleft = %d, right = %d", left, right); */
	if (left <= right)
	{
		middle = (left + right) / 2;
		switch (compareTwoString(key, name[middle]))
		{
		case -1:
			return binarySearchByRecursion(name, key, left, middle - 1);
		case 0:
			return middle;
		case 1:
			return binarySearchByRecursion(name, key, middle + 1, right);
		}
	}
	return -1;
}

int compareTwoString(char str1[], char str2[])
{ /*  ڿ ϴ Լ */
	int cmp;
	cmp = strcmp(str1, str2);
	if (cmp == 0)
		return 0;
	else
		return (cmp < 0) ? -1 : 1;
}
