#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h> /* memset */
int *IntArray(int nR, int nC);
void ZeroArray(int *pM, int nR, int nC);
void SetArrayElement(int *pM, int nR, int nC, int i, int j, int value);
void PrintArray(int *pM, int nR, int nC);

int main()
{
	int *pM;
	int nR = 3; /* (row)     */
	int nC = 4; /* (column)  */
	pM = IntArray(nR, nC);
	ZeroArray(pM, nR, nC);
	SetArrayElement(pM, nR, nC, 1, 2, 5);
	PrintArray(pM, nR, nC);
	free(pM);
	return 0;
}

int *IntArray(int nR, int nC)
{
	int *pM;
	pM = (int *) malloc(sizeof(int) * nR * nC);
	if (!pM)
	{
		printf("޸𸮸 Ҵ  ϴ.");
		exit(1);
	}
	return pM;
}

void ZeroArray(int *pM, int nR, int nC)
{
	/*
	 int i, j, k;
	 for(i=0; i<nR; i++)
	     for(j=0; j<nC; j++)
	     {
	         k= i*nC + j;
	         pM[k] = 0;
	     }
	 */
	memset(pM, 0, sizeof(int) * nR * nC);
}

void SetArrayElement(int *pM, int nR, int nC, int i, int j, int value)
{
	int k;
	k = i * nC + j;
	if (k < nR * nC)
		pM[k] = value;
}

void PrintArray(int *pM, int nR, int nC)
{
	int i, j, k;
	for (i = 0; i < nR; i++)
	{
		for (j = 0; j < nC; j++)
		{
			k = i * nC + j;
			printf("%2d", pM[k]);
		}
		printf("\n");
	}
}
