#include <stdio.h>
#include <malloc.h>
typedef struct treeNode *PTREENODE;
typedef struct treeNode {
	int data;
	PTREENODE leftChild;
	PTREENODE rightChild;
} TREENODE;

void visitTreeInOrder(PTREENODE ptr);
void RemoveAllTreeNode(PTREENODE ptr);

int main()
{
	PTREENODE ptrHead, ptr;
	/*   */
	ptr = (PTREENODE) malloc(sizeof(TREENODE));
	ptr->data = 20;
	ptr->leftChild = NULL;
	ptr->rightChild = NULL;
	ptrHead = ptr;

	/*   */
	ptr = (PTREENODE) malloc(sizeof(TREENODE));
	ptr->data = 10;
	ptr->leftChild = NULL;
	ptr->rightChild = NULL;
	ptrHead->leftChild = ptr;  /*   */

	/*   */
	ptr = (PTREENODE) malloc(sizeof(TREENODE));
	ptr->data = 30;
	ptr->leftChild = NULL;
	ptr->rightChild = NULL;
	ptrHead->rightChild = ptr; /*   */
	ptr = ptrHead;
	visitTreeInOrder(ptr);     /*  湮 */
	RemoveAllTreeNode(ptrHead);
	return 0;
}

void visitTreeInOrder(PTREENODE ptr)
{ /*  ȸ: (left, root, right) */
	if (ptr != NULL)
	{
		visitTreeInOrder(ptr->leftChild);
		printf("%d ", ptr->data);
		visitTreeInOrder(ptr->rightChild);
	}
}

void RemoveAllTreeNode(PTREENODE ptr)
{
	/*  ȸ: (left, right, root) */
	if (ptr != NULL)
	{
		RemoveAllTreeNode(ptr->leftChild);
		RemoveAllTreeNode(ptr->rightChild);
		/* printf("Delete : %p: %d\n", ptr, ptr->data); */
		free(ptr); /* ptr = NULL; */
	}
}
