#include <iostream>
using namespace std;
class CB; //  (forward reference)
class CA
{
	int m_aData;
public:
	CA(int a = 0) { m_aData = a; }
	~CA() {};
	int difference(CB ob2);

	// Ϲ  Լ +  
	friend int operator+(CA ob1, CB ob2);
};

class CB
{
	int m_bData;
public:
	CB(int b = 0) { m_bData = b; }
	~CB() {};

	// CA Ŭ ִ difference Լ  
	friend int CA::difference(CB ob2);

	// Ϲ  Լ +  
	friend int operator+(CA ob1, CB ob2);
};

int CA::difference(CB ob2)
{
	// difference Լ CB  
	// ob2.m_bData  
	return m_aData - ob2.m_bData;
}

int operator+(CA ob1, CB ob2) // CA Ŭ  ƴ
{
	//  Լ + CA CB Ŭ  
	// ob1.m_aData, ob2.m_bData  
	return ob1.m_aData + ob2.m_bData;
}

int main()
{
	CA ob1(20);
	CB ob2(10);
	int diff = ob1.difference(ob2);
	int sum = ob1 + ob2;
	cout << "diff = " << diff << "\n";
	cout << "sum = " << sum << "\n";
	return 0;
}
