#include <stdio.h>
#include <stdlib.h>  /* for exit() */
#define MAXSIZE 5
void push(char stack[], int *top, char data);
char pop(char stack[], int *top);

int main()
{
	char stack[MAXSIZE];
	int top = -1;
	char data;

	push(stack, &top, 'A');
	push(stack, &top, 'B');
	push(stack, &top, 'C');
	push(stack, &top, 'D');
	push(stack, &top, 'E');
	/* push(stack, &top, 'F'); */ /* Stack full */

	printf("top = %2d\n", top);
	for (; top != -1;) /* top = -1̸     */
	{
		data = pop(stack, &top);
		printf("top = %2d, data = %c\n", top, data);
	}
	return 0;
}

void push(char stack[], int *top, char data)
{
	if (*top >= MAXSIZE - 1)
	{
		printf("Stack full\n");
		exit(1);
	}
	else
		stack[++(*top)] = data;
}

char pop(char stack[], int *top)
{
	if (*top < 0)
	{
		printf("Stack empty\n");
		exit(1);
	}
	else
		return stack[(*top)--];
}
