#include <stdio.h>
#include <malloc.h>
typedef struct treeNode *PTREENODE;
typedef struct treeNode {
	int data;
	PTREENODE leftChild;
	PTREENODE rightChild;
} TREENODE;

void visitTreeInOrder(PTREENODE ptr);
PTREENODE createNode(int data);

int main()
{
	PTREENODE ptrHead, ptr;
	ptrHead = createNode(20);
	ptr = createNode(10);
	ptrHead->leftChild = ptr;

	ptr = createNode(30);
	ptrHead->rightChild = ptr;

	ptr = ptrHead;
	visitTreeInOrder(ptr);
	return 0;
}

PTREENODE createNode(int data)
{
	PTREENODE ptr;
	ptr = (PTREENODE) malloc(sizeof(TREENODE));
	ptr->data = data;
	ptr->leftChild = NULL;
	ptr->rightChild = NULL;
	return ptr;
}

void visitTreeInOrder(PTREENODE ptr)
{ /*  ȸ: (left, root, right) */
	if (ptr != NULL)
	{
		visitTreeInOrder(ptr->leftChild);
		printf("%d ", ptr->data);
		visitTreeInOrder(ptr->rightChild);
	}
}
