#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXSIZE  100
typedef struct score {
	char name[20];
	int kor;
	int eng;
	int math;
	int sum;
	float average;
} SCORE;

void readData(char *fname, SCORE student[], int *nSize);
void writeData(char *fname, SCORE student[], int nSize);
void calculateAverage(SCORE student[], int nSize);

int main()
{
	SCORE student[MAXSIZE];
	int nSize;
	readData("data.txt", student, &nSize);
	calculateAverage(student, nSize);
	writeData("result.txt", student, nSize);
	return 0;
}

void readData(char *fname, SCORE student[], int *nSize)
{
	int k, e, m;
	char name[20];
	int n = 0;
	FILE *fp;
/*	if ((fp = fopen(fname, "r")) == NULL) */
	fopen_s(&fp, fname, "r");
	if(fp == NULL)
	{
		printf("Է    ϴ.\n");
		exit(1);
	}
/*	while (fscanf(fp, "%s %d %d %d", name, &k, &e, &m) != EOF) */
	while (fscanf_s(fp, "%s %d %d %d", name, sizeof(name), &k, &e, &m) != EOF) 
	{
		/*  : student[n].name = name; */
	/*	strcpy(student[n].name, name); */
		strcpy_s(student[n].name, sizeof(student[n].name), name);
		student[n].kor = k;
		student[n].eng = e;
		student[n].math = m;
		n++;
	}
	*nSize = n;
	fclose(fp);
}

void writeData(char *fname, SCORE student[], int nSize)
{
	FILE *fp;
	int i;
/*	if ((fp = fopen(fname, "w")) == NULL) */
	fopen_s(&fp, fname, "w");
	if(fp == NULL)
	{
		printf("    ϴ.\n");
		exit(1);
	}
	fprintf(fp, "# :  name    kor  eng math sum  avg\n");
	fprintf(fp, "------------------------------------------\n");
	for (i = 0; i < nSize; i++)
	{
		fprintf(fp, "%d : %6s %4d %4d %4d %4d %10.6f\n", i, student[i].name,
			student[i].kor, student[i].eng, student[i].math,
			student[i].sum, student[i].average);
	}
}

void calculateAverage(SCORE student[], int nSize)
{
	int i;
	for (i = 0; i < nSize; i++)
	{
		student[i].sum = student[i].kor + student[i].eng + student[i].math;
		student[i].average = student[i].sum / 3.0f;
	}
}
