#include <iostream>
#include <string.h>
using namespace std;
class CMyString
{
public:
	char *m_pStr;
public:
	CMyString(char *str = NULL); // 
	CMyString(const CMyString& s); //  
	~CMyString();
	CMyString operator+(const CMyString& s); //  Լ
	CMyString& operator=(const CMyString& s); //  Լ
	void Display();
};

CMyString::CMyString(char *str) // 
{
	cout << "\n";
	if (str)
	{
		int len = strlen(str);
		m_pStr = new char[len + 1];
	//	strcpy(m_pStr, str);
		strcpy_s(m_pStr, len+1, str);
	}
	else
	{
		m_pStr = NULL;
	}
}

CMyString::CMyString(const CMyString& s) //  
{
	cout << " \n";
	int len = strlen(s.m_pStr);
	m_pStr = new char[len + 1];
//	strcpy(m_pStr, s.m_pStr);
	strcpy_s(m_pStr, len+1, s.m_pStr);
}

CMyString::~CMyString()
{
	cout << "Ҹ\n";
	delete m_pStr;

}

void CMyString::Display()
{
	if (m_pStr)
		cout << m_pStr << "\n";
}

CMyString CMyString::operator+(const CMyString& s)
{
	cout << "+  Լ \n";
	CMyString tmpObj;
	int len = strlen(m_pStr) + strlen(s.m_pStr);
	tmpObj.m_pStr = new char[len+1];

//	strcpy(tmpObj.m_pStr, m_pStr);
	strcpy_s(tmpObj.m_pStr, len+1, m_pStr);

//	strcat(tmpObj.m_pStr, s.m_pStr);
	strcat_s(tmpObj.m_pStr, len+1, s.m_pStr);

	return tmpObj; //   ȣ
	// tmpObj  Ҹڿ  ڿ  Ҹ ȣ
}

CMyString& CMyString::operator=(const CMyString& s)
{
	cout << "=  Լ \n";
	delete m_pStr;
	int len = strlen(s.m_pStr);
	m_pStr = new char[len+1];
//	strcpy(m_pStr, s.m_pStr);
	strcpy_s(m_pStr, len+1, s.m_pStr);
	return *this;
}

int main()
{
	CMyString s1("abcd");
	CMyString s2("efg");
	CMyString s3, s4, s5;
	s3 = s1 + s2; // +  Լ, =  Լ ȣ
	s5 = s4 = s1; // =  Լ 2 ȣ
	s1.Display(); // "abcd"
	s2.Display(); // "efg"
	s3.Display(); // "abcdefg"
	s4.Display(); // "abcd"
	s5.Display(); // "abcd"
	return 0;
}
