#include <iostream>
#include <iterator> 
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>
using namespace std;
int main()
{
	int nArr1[] = { 2, 0, 6, 8 };
	int nArr2[] = { 1, 1, 2, 2 };

	vector<int> V1(nArr1, nArr1 + 4);
	vector<int> V2(nArr2, nArr2 + 4);
	vector<int> V3(V1.size());

	cout << "V1 = { ";
	copy(V1.begin(), V1.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	cout << "V2 = { ";
	copy(V2.begin(), V2.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	transform(V1.begin(), V1.end(), V2.begin(), V3.begin(), plus<int> ());

	cout << "V3 = V1 + V2 = { ";
	copy(V3.begin(), V3.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	// V3.assign(V3.size(), 0);
	transform(V1.begin(), V1.end(), V2.begin(), V3.begin(), minus<int> ());

	cout << "V3 = V1 - V2 = { ";
	copy(V3.begin(), V3.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	transform(V1.begin(), V1.end(), V2.begin(), V3.begin(), multiplies<int> ());
	cout << "V3 = V1 * V2 = { ";
	copy(V3.begin(), V3.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	transform(V1.begin(), V1.end(), V2.begin(), V3.begin(), divides<int> ());
	cout << "V3 = V1 / V2 = { ";
	copy(V3.begin(), V3.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	transform(V1.begin(), V1.end(), V2.begin(), V3.begin(), greater<int> ());
	cout << "V3 = V1 > V2 = { ";
	copy(V3.begin(), V3.end(), ostream_iterator<int> (cout, " "));
	cout << "}" << endl;

	return 0;
}
